'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _shapes = require('./shapes');

var shapes = _interopRequireWildcard(_shapes);

var _findMatchingTextIndex = require('./utils/findMatchingTextIndex');

var _findMatchingTextIndex2 = _interopRequireDefault(_findMatchingTextIndex);

var _deprecated = require('./utils/deprecated');

var _deprecated2 = _interopRequireDefault(_deprecated);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function setSelection(input, text, matchingText) {
  if (text === null) {
    input.value = null;
  } else {
    input.value = matchingText;
    if (text.length !== matchingText.length) {
      input.setSelectionRange(text.length, matchingText.length);
    }
  }
}

var Autocomplete = function (_PureComponent) {
  (0, _inherits3.default)(Autocomplete, _PureComponent);

  function Autocomplete(props) {
    (0, _classCallCheck3.default)(this, Autocomplete);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Autocomplete.__proto__ || (0, _getPrototypeOf2.default)(Autocomplete)).call(this, props));

    _this.registerInput = function (c) {
      return _this.input = c;
    };

    _this.handleSelectionChange = function () {
      var input = _this.getInput();
      if (input.selectionStart === input.selectionEnd && input.value !== _this.state.value) {
        _this.setValue(input.value, _this.props.options);
      }
    };

    _this.handleChange = function (e) {
      var value = e.target.value;

      _this.setValue(value, _this.props.options);

      if (_this.props.onChange) {
        _this.props.onChange(e);
      }
    };

    _this.handleKeyDown = function (e) {
      var keyMap = {
        Backspace: _this.handleBackspaceKeyDown,
        Enter: _this.handleEnterKeyDown
      };

      if (keyMap[e.key]) {
        keyMap[e.key](e);
      }

      if (_this.props.onKeyDown) {
        _this.props.onKeyDown(e);
      }
    };

    _this.handleBackspaceKeyDown = function () {
      var input = _this.getInput();
      if (input.selectionStart !== input.selectionEnd && input.selectionEnd === input.value.length && input.selectionStart !== 0) {
        input.value = input.value.substr(0, input.selectionStart);
      }
    };

    _this.handleEnterKeyDown = function () {
      var input = _this.getInput();

      setSelection(input, _this.state.matchingText, _this.state.matchingText);
      input.blur();
    };

    _this.state = {
      matchingText: null,
      value: props.value
    };
    return _this;
  }

  (0, _createClass3.default)(Autocomplete, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      document.addEventListener('selectionchange', this.handleSelectionChange);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.removeEventListener('selectionchange', this.handleSelectionChange);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.props.value !== nextProps.value) {
        this.setValue(nextProps.value, nextProps.options);
      }
    }
  }, {
    key: 'componentWillUpdate',
    value: function componentWillUpdate(nextProps, nextState) {
      if (this.props.options !== nextProps.options && this.props.value === nextProps.value) {
        var match = (0, _findMatchingTextIndex2.default)(nextState.value, nextProps.options);

        var _match = (0, _slicedToArray3.default)(match, 2);

        var matchingText = _match[1];

        this.setState({ matchingText: matchingText });
      }
    }
  }, {
    key: 'setValue',
    value: function setValue(value, options) {
      var match = (0, _findMatchingTextIndex2.default)(value, options);

      var _match2 = (0, _slicedToArray3.default)(match, 2);

      var matchingText = _match2[1];

      this.setState({ value: value, matchingText: matchingText });
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      if (this.state.value !== prevState.value || this.state.matchingText !== prevState.matchingText) {
        if (this.state.matchingText) {
          var input = this.getInput();
          setSelection(input, this.state.value, this.state.matchingText);
        }
      }
    }
  }, {
    key: 'getInput',
    value: function getInput() {
      if (this.props.getInputElement) {
        return this.props.getInputElement();
      }

      if (this.input) {
        return this.input;
      }

      // eslint-disable-next-line
      (0, _deprecated2.default)('Automatic input resolving is deprecated: please provide input instance via `getInputElement` or `registerInput`');

      var el = _reactDom2.default.findDOMNode(this);
      return el.tagName === 'INPUT' ? el : el.getElementsByTagName('INPUT')[0];
    }
  }, {
    key: 'render',
    value: function render() {
      var children = this.props.children;
      var _state = this.state;
      var matchingText = _state.matchingText;
      var value = _state.value;

      var inputProps = {
        value: matchingText || value,
        onKeyDown: this.handleKeyDown,
        onChange: this.handleChange
      };

      if (typeof children === 'function') {
        return children(inputProps, { matchingText: matchingText, value: value, registerInput: this.registerInput });
      } else {
        var input = _react.Children.only(children);
        return _react2.default.cloneElement(input, (0, _extends3.default)({}, inputProps, input.props));
      }
    }
  }]);
  return Autocomplete;
}(_react.PureComponent);

Autocomplete.propTypes = {
  getInputElement: _react.PropTypes.func,
  value: _react.PropTypes.string,
  options: _react.PropTypes.arrayOf(shapes.ITEM_OR_STRING).isRequired
};
Autocomplete.defaultProps = {};
exports.default = Autocomplete;