'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Autocomplete = require('./Autocomplete');

var _Autocomplete2 = _interopRequireDefault(_Autocomplete);

var _Dropdown = require('./Dropdown');

var _Dropdown2 = _interopRequireDefault(_Dropdown);

var _Autosize = require('./Autosize');

var _Autosize2 = _interopRequireDefault(_Autosize);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Combobox = function (_PureComponent) {
  (0, _inherits3.default)(Combobox, _PureComponent);

  function Combobox() {
    (0, _classCallCheck3.default)(this, Combobox);
    return (0, _possibleConstructorReturn3.default)(this, (Combobox.__proto__ || (0, _getPrototypeOf2.default)(Combobox)).apply(this, arguments));
  }

  (0, _createClass3.default)(Combobox, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var autosize = _props.autosize;
      var autocomplete = _props.autocomplete;
      var children = _props.children;
      var props = (0, _objectWithoutProperties3.default)(_props, ['autosize', 'autocomplete', 'children']);


      if (autosize && autocomplete) {
        return this.renderAutosizeAutocompleteDropdown(children, props);
      } else if (autosize) {
        return this.renderAutosizeDropdown(children, props);
      } else if (autocomplete) {
        return this.renderAutocompleteDropdown(children, props);
      } else {
        return this.renderDropdown(children, props);
      }
    }
  }, {
    key: 'renderAutosizeAutocompleteDropdown',
    value: function renderAutosizeAutocompleteDropdown(children, props) {
      var _this2 = this;

      return _react2.default.createElement(
        _Dropdown2.default,
        props,
        function (dropdownInputProps, _ref) {
          var textValue = _ref.textValue;
          return _react2.default.createElement(
            _Autocomplete2.default,
            {
              value: textValue,
              onChange: dropdownInputProps.onChange,
              onKeyDown: dropdownInputProps.onKeyDown,
              options: props.options,
              getInputElement: props.getInputElement
            },
            function (inputProps, _ref2) {
              var matchingText = _ref2.matchingText;
              var registerInput = _ref2.registerInput;
              return _react2.default.createElement(
                _Autosize2.default,
                {
                  value: inputProps.value,
                  onChange: inputProps.onChange,
                  defaultWidth: props.defaultWidth,
                  getInputElement: props.getInputElement,
                  getSizerContainer: props.getSizerContainer
                },
                function (autosizeInputProps, _ref3) {
                  var width = _ref3.width;
                  return _this2.renderChildren(children, (0, _extends3.default)({}, dropdownInputProps, inputProps, autosizeInputProps), {
                    matchingText: matchingText, width: width, registerInput: registerInput
                  });
                }
              );
            }
          );
        }
      );
    }
  }, {
    key: 'renderAutosizeDropdown',
    value: function renderAutosizeDropdown(children, props) {
      var _this3 = this;

      return _react2.default.createElement(
        _Dropdown2.default,
        props,
        function (inputProps, _ref4) {
          var textValue = _ref4.textValue;
          return _react2.default.createElement(
            _Autosize2.default,
            {
              value: textValue,
              onChange: inputProps.onChange,
              defaultWidth: props.defaultWidth,
              getInputElement: props.getInputElement,
              getSizerContainer: props.getSizerContainer
            },
            function (autosizeInputProps, _ref5) {
              var width = _ref5.width;
              return _this3.renderChildren(children, (0, _extends3.default)({}, inputProps, autosizeInputProps), { width: width });
            }
          );
        }
      );
    }
  }, {
    key: 'renderAutocompleteDropdown',
    value: function renderAutocompleteDropdown(children, props) {
      var _this4 = this;

      return _react2.default.createElement(
        _Dropdown2.default,
        props,
        function (dropdownInputProps, _ref6) {
          var textValue = _ref6.textValue;
          return _react2.default.createElement(
            _Autocomplete2.default,
            {
              value: textValue,
              onChange: dropdownInputProps.onChange,
              onKeyDown: dropdownInputProps.onKeyDown,
              options: props.options,
              getInputElement: props.getInputElement
            },
            function (inputProps, _ref7) {
              var matchingText = _ref7.matchingText;
              var registerInput = _ref7.registerInput;
              return _this4.renderChildren(children, (0, _extends3.default)({}, dropdownInputProps, inputProps), { matchingText: matchingText, registerInput: registerInput });
            }
          );
        }
      );
    }
  }, {
    key: 'renderDropdown',
    value: function renderDropdown(children, props) {
      var _this5 = this;

      return _react2.default.createElement(
        _Dropdown2.default,
        props,
        function (inputProps) {
          return _this5.renderChildren(children, inputProps);
        }
      );
    }
  }, {
    key: 'renderChildren',
    value: function renderChildren(children, props) {
      var params = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

      if (typeof children === 'function') {
        return children(props, params);
      } else {
        var input = _react.Children.only(children);

        return _react2.default.cloneElement(input, (0, _extends3.default)({}, props, input.props));
      }
    }
  }]);
  return Combobox;
}(_react.PureComponent);

Combobox.propTypes = {
  autosize: _react.PropTypes.bool,
  autocomplete: _react.PropTypes.bool
};
exports.default = Combobox;